
import urllib, urllib2, json

def couch_webservice_request(request,*args,**kwargs):
    baseurl = 'https://edwardslab.bmcb.georgetown.edu/couchdb'
    url = baseurl + "/" + request.lstrip('/')
    return webservice_request(url,*args,**kwargs)

def uniprot_webservice_request(request,*args,**kwargs):
    baseurl = 'https://www.ebi.ac.uk/proteins/api'
    url = baseurl + "/" + request.lstrip('/')
    return webservice_request(url,*args,**kwargs)

def webservice_request(request,
                       payload={},
                       method='GET',
                       username=None,
                       password=None):
    headers = {'Content-type': 'application/json',
               'Accept':       'application/json'}
    if username != None:
        pm = urllib2.HTTPPasswordMgrWithDefaultRealm()
        pm.add_password(None,request,username,password)
        ah = urllib2.HTTPBasicAuthHandler(pm)
        opener = urllib2.build_opener(ah)
    else:
        opener = urllib2.build_opener(urllib2.HTTPHandler())
    url = request
    if method == 'GET':
        if payload != {}:
            url += '?' + urllib.urlencode(payload)
        request = urllib2.Request(url, headers=headers)
    elif method == 'POST':
        request = urllib2.Request(url, json.dumps(payload), headers=headers)
    elif method == 'PUT':
        request = urllib2.Request(url, json.dumps(payload), headers=headers)
        request.get_method = lambda: 'PUT'
    elif method == 'DELETE':
        request = urllib2.Request(url, json.dumps(payload), headers=headers)
        request.get_method = lambda: 'DELETE'
    else:
        raise RuntimeError('Bad method '+method)
    try:
        return json.loads(opener.open(request).read())
    except urllib2.HTTPError, e:
        return {u'error': True, u'errorcode': e.code, u'errormsg': e.msg}
    return {u'error': True}
